// generated by Fast Light User Interface Designer (fluid) version 1.0107

#include "MainUI.h"
#include "WaveformGenerator.h"
extern WaveformGenerator* waveformGenerator;
#include "Oscilloscope.h"
extern Oscilloscope* oscilloscope;
#include "ITC.h"
extern ITC* itc;

void UserInterface::cb_About_i(Fl_Button*, void*) {
  fl_alert("WGO (Waveform Generator and Oscilloscope)\
\nVersion 1.03\
\nAuthor: Payne Y. Chang\
\neMail: paynechang@@mail.utexas.edu\
\nWebsite: www.clm.utexas.edu/~payne");
}
void UserInterface::cb_About(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->user_data()))->cb_About_i(o,v);
}

void UserInterface::cb_Power_i(Fl_Button* o, void*) {
  waveformGenerator->setPower(o->value());
}
void UserInterface::cb_Power(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_Power_i(o,v);
}

void UserInterface::cb_Sine_i(Fl_Menu_*, void*) {
  waveformGenerator->setWaveformType('s');
}
void UserInterface::cb_Sine(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_Sine_i(o,v);
}

void UserInterface::cb_Square_i(Fl_Menu_*, void*) {
  waveformGenerator->setWaveformType('q');
}
void UserInterface::cb_Square(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_Square_i(o,v);
}

void UserInterface::cb_Triangle_i(Fl_Menu_*, void*) {
  waveformGenerator->setWaveformType('t');
}
void UserInterface::cb_Triangle(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_Triangle_i(o,v);
}

void UserInterface::cb_Sawtooth_i(Fl_Menu_*, void*) {
  waveformGenerator->setWaveformType('a');
}
void UserInterface::cb_Sawtooth(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_Sawtooth_i(o,v);
}

Fl_Menu_Item UserInterface::menu_Waveform[] = {
 {"Sine", 0,  (Fl_Callback*)UserInterface::cb_Sine, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Square", 0,  (Fl_Callback*)UserInterface::cb_Square, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Triangle", 0,  (Fl_Callback*)UserInterface::cb_Triangle, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Sawtooth", 0,  (Fl_Callback*)UserInterface::cb_Sawtooth, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

void UserInterface::cb_0_i(Fl_Menu_*, void*) {
  itc->setDACChannelNo(0);
}
void UserInterface::cb_0(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_0_i(o,v);
}

void UserInterface::cb_1_i(Fl_Menu_*, void*) {
  itc->setDACChannelNo(1);
}
void UserInterface::cb_1(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_1_i(o,v);
}

void UserInterface::cb_2_i(Fl_Menu_*, void*) {
  itc->setDACChannelNo(2);
}
void UserInterface::cb_2(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_2_i(o,v);
}

void UserInterface::cb_3_i(Fl_Menu_*, void*) {
  itc->setDACChannelNo(3);
}
void UserInterface::cb_3(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_3_i(o,v);
}

Fl_Menu_Item UserInterface::menu_DAC[] = {
 {"0", 0,  (Fl_Callback*)UserInterface::cb_0, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"1", 0,  (Fl_Callback*)UserInterface::cb_1, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"2", 0,  (Fl_Callback*)UserInterface::cb_2, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"3", 0,  (Fl_Callback*)UserInterface::cb_3, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

void UserInterface::cb_Frequency_i(Fl_Value_Slider* o, void*) {
  waveformGenerator->setFrequencyRatio(o->value());
}
void UserInterface::cb_Frequency(Fl_Value_Slider* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_Frequency_i(o,v);
}

void UserInterface::cb_100_i(Fl_Menu_*, void*) {
  waveformGenerator->setFrequencyRange(100e3);
}
void UserInterface::cb_100(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_100_i(o,v);
}

void UserInterface::cb_10_i(Fl_Menu_*, void*) {
  waveformGenerator->setFrequencyRange(10e3);
}
void UserInterface::cb_10(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_10_i(o,v);
}

void UserInterface::cb_11_i(Fl_Menu_*, void*) {
  waveformGenerator->setFrequencyRange(1e3);
}
void UserInterface::cb_11(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_11_i(o,v);
}

void UserInterface::cb_1001_i(Fl_Menu_*, void*) {
  waveformGenerator->setFrequencyRange(100);
}
void UserInterface::cb_1001(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_1001_i(o,v);
}

Fl_Menu_Item UserInterface::menu_wgFrequencyOrder[] = {
 {"100 kHz", 0,  (Fl_Callback*)UserInterface::cb_100, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"10 kHz", 0,  (Fl_Callback*)UserInterface::cb_10, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"1 kHz", 0,  (Fl_Callback*)UserInterface::cb_11, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"100 Hz", 0,  (Fl_Callback*)UserInterface::cb_1001, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

void UserInterface::cb_DC_i(Fl_Value_Slider* o, void*) {
  waveformGenerator->setDCOffset(o->value());
}
void UserInterface::cb_DC(Fl_Value_Slider* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_DC_i(o,v);
}

void UserInterface::cb_Amplitude_i(Fl_Value_Slider* o, void*) {
  waveformGenerator->setAmplitudeRatio(o->value());
}
void UserInterface::cb_Amplitude(Fl_Value_Slider* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_Amplitude_i(o,v);
}

void UserInterface::cb_101_i(Fl_Menu_*, void*) {
  waveformGenerator->setAmplitudeRange(10);
}
void UserInterface::cb_101(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_101_i(o,v);
}

void UserInterface::cb_12_i(Fl_Menu_*, void*) {
  waveformGenerator->setAmplitudeRange(1);
}
void UserInterface::cb_12(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_12_i(o,v);
}

void UserInterface::cb_1002_i(Fl_Menu_*, void*) {
  waveformGenerator->setAmplitudeRange(100e-3);
}
void UserInterface::cb_1002(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_1002_i(o,v);
}

void UserInterface::cb_102_i(Fl_Menu_*, void*) {
  waveformGenerator->setAmplitudeRange(10e-3);
}
void UserInterface::cb_102(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_102_i(o,v);
}

Fl_Menu_Item UserInterface::menu_x[] = {
 {"10 V", 0,  (Fl_Callback*)UserInterface::cb_101, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"1 V", 0,  (Fl_Callback*)UserInterface::cb_12, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"100 mV", 0,  (Fl_Callback*)UserInterface::cb_1002, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"10 mV", 0,  (Fl_Callback*)UserInterface::cb_102, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

void UserInterface::cb_Power1_i(Fl_Button* o, void*) {
  oscilloscope->setPower(o->value());
}
void UserInterface::cb_Power1(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_Power1_i(o,v);
}

void UserInterface::cb_01_i(Fl_Menu_*, void*) {
  itc->setADCChannelNo(0);
}
void UserInterface::cb_01(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_01_i(o,v);
}

void UserInterface::cb_13_i(Fl_Menu_*, void*) {
  itc->setADCChannelNo(1);
}
void UserInterface::cb_13(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_13_i(o,v);
}

void UserInterface::cb_21_i(Fl_Menu_*, void*) {
  itc->setADCChannelNo(2);
}
void UserInterface::cb_21(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_21_i(o,v);
}

void UserInterface::cb_31_i(Fl_Menu_*, void*) {
  itc->setADCChannelNo(3);
}
void UserInterface::cb_31(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_31_i(o,v);
}

void UserInterface::cb_4_i(Fl_Menu_*, void*) {
  itc->setADCChannelNo(4);
}
void UserInterface::cb_4(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_4_i(o,v);
}

void UserInterface::cb_5_i(Fl_Menu_*, void*) {
  itc->setADCChannelNo(5);
}
void UserInterface::cb_5(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_5_i(o,v);
}

void UserInterface::cb_6_i(Fl_Menu_*, void*) {
  itc->setADCChannelNo(6);
}
void UserInterface::cb_6(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_6_i(o,v);
}

void UserInterface::cb_7_i(Fl_Menu_*, void*) {
  itc->setADCChannelNo(7);
}
void UserInterface::cb_7(Fl_Menu_* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_7_i(o,v);
}

Fl_Menu_Item UserInterface::menu_ADC[] = {
 {"0", 0,  (Fl_Callback*)UserInterface::cb_01, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"1", 0,  (Fl_Callback*)UserInterface::cb_13, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"2", 0,  (Fl_Callback*)UserInterface::cb_21, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"3", 0,  (Fl_Callback*)UserInterface::cb_31, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"4", 0,  (Fl_Callback*)UserInterface::cb_4, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"5", 0,  (Fl_Callback*)UserInterface::cb_5, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"6", 0,  (Fl_Callback*)UserInterface::cb_6, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"7", 0,  (Fl_Callback*)UserInterface::cb_7, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

void UserInterface::cb_DC1_i(Fl_Value_Slider* o, void*) {
  oscilloscope->setDCOffset(o->value());
}
void UserInterface::cb_DC1(Fl_Value_Slider* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->user_data()))->cb_DC1_i(o,v);
}

void UserInterface::cb_02_i(Fl_Button*, void*) {
  oscilloscope->setTimeDiv(0.2);
timeDiv->label("TIME/DIV = 0.2 s");
}
void UserInterface::cb_02(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_02_i(o,v);
}

void UserInterface::cb_03_i(Fl_Button*, void*) {
  oscilloscope->setTimeDiv(0.1);
timeDiv->label("TIME/DIV = 0.1 s");
}
void UserInterface::cb_03(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_03_i(o,v);
}

void UserInterface::cb_50_i(Fl_Button*, void*) {
  oscilloscope->setTimeDiv(50e-3);
timeDiv->label("TIME/DIV = 50 ms");
}
void UserInterface::cb_50(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_50_i(o,v);
}

void UserInterface::cb_20_i(Fl_Button*, void*) {
  oscilloscope->setTimeDiv(20e-3);
timeDiv->label("TIME/DIV = 20 ms");
}
void UserInterface::cb_20(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_20_i(o,v);
}

void UserInterface::cb_103_i(Fl_Button*, void*) {
  oscilloscope->setTimeDiv(10e-3);
timeDiv->label("TIME/DIV = 10 ms");
}
void UserInterface::cb_103(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_103_i(o,v);
}

void UserInterface::cb_51_i(Fl_Button*, void*) {
  oscilloscope->setTimeDiv(5e-3);
timeDiv->label("TIME/DIV = 5 ms");
}
void UserInterface::cb_51(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_51_i(o,v);
}

void UserInterface::cb_22_i(Fl_Button*, void*) {
  oscilloscope->setTimeDiv(2e-3);
timeDiv->label("TIME/DIV = 2 ms");
}
void UserInterface::cb_22(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_22_i(o,v);
}

void UserInterface::cb_14_i(Fl_Button*, void*) {
  oscilloscope->setTimeDiv(1e-3);
timeDiv->label("TIME/DIV = 1 ms");
}
void UserInterface::cb_14(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_14_i(o,v);
}

void UserInterface::cb_04_i(Fl_Button*, void*) {
  oscilloscope->setTimeDiv(0.5e-3);
timeDiv->label("TIME/DIV = 0.5 ms");
}
void UserInterface::cb_04(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_04_i(o,v);
}

void UserInterface::cb_05_i(Fl_Button*, void*) {
  oscilloscope->setTimeDiv(0.2e-3);
timeDiv->label("TIME/DIV = 0.2 ms");
}
void UserInterface::cb_05(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_05_i(o,v);
}

void UserInterface::cb_06_i(Fl_Button*, void*) {
  oscilloscope->setTimeDiv(0.1e-3);
timeDiv->label("TIME/DIV = 0.1 ms");
}
void UserInterface::cb_06(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_06_i(o,v);
}

void UserInterface::cb_501_i(Fl_Button*, void*) {
  oscilloscope->setTimeDiv(50e-6);
timeDiv->label("TIME/DIV = 50 us");
}
void UserInterface::cb_501(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_501_i(o,v);
}

void UserInterface::cb_201_i(Fl_Button*, void*) {
  oscilloscope->setTimeDiv(20e-6);
timeDiv->label("TIME/DIV = 20 us");
}
void UserInterface::cb_201(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_201_i(o,v);
}

void UserInterface::cb_104_i(Fl_Button*, void*) {
  oscilloscope->setTimeDiv(10e-6);
timeDiv->label("TIME/DIV = 10 us");
}
void UserInterface::cb_104(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_104_i(o,v);
}

void UserInterface::cb_52_i(Fl_Button*, void*) {
  oscilloscope->setVoltDiv(5);
voltsDiv->label("VOLTS/DIV = 5 V");
}
void UserInterface::cb_52(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_52_i(o,v);
}

void UserInterface::cb_23_i(Fl_Button*, void*) {
  oscilloscope->setVoltDiv(2);
voltsDiv->label("VOLTS/DIV = 2 V");
}
void UserInterface::cb_23(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_23_i(o,v);
}

void UserInterface::cb_15_i(Fl_Button*, void*) {
  oscilloscope->setVoltDiv(1);
voltsDiv->label("VOLTS/DIV = 1 V");
}
void UserInterface::cb_15(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_15_i(o,v);
}

void UserInterface::cb_07_i(Fl_Button*, void*) {
  oscilloscope->setVoltDiv(0.5);
voltsDiv->label("VOLTS/DIV = 0.5 V");
}
void UserInterface::cb_07(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_07_i(o,v);
}

void UserInterface::cb_08_i(Fl_Button*, void*) {
  oscilloscope->setVoltDiv(0.2);
voltsDiv->label("VOLTS/DIV = 0.2 V");
}
void UserInterface::cb_08(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_08_i(o,v);
}

void UserInterface::cb_09_i(Fl_Button*, void*) {
  oscilloscope->setVoltDiv(0.1);
voltsDiv->label("VOLTS/DIV = 0.1 V");
}
void UserInterface::cb_09(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_09_i(o,v);
}

void UserInterface::cb_502_i(Fl_Button*, void*) {
  oscilloscope->setVoltDiv(50e-3);
voltsDiv->label("VOLTS/DIV = 50 mV");
}
void UserInterface::cb_502(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_502_i(o,v);
}

void UserInterface::cb_202_i(Fl_Button*, void*) {
  oscilloscope->setVoltDiv(20e-3);
voltsDiv->label("VOLTS/DIV = 20 mV");
}
void UserInterface::cb_202(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_202_i(o,v);
}

void UserInterface::cb_105_i(Fl_Button*, void*) {
  oscilloscope->setVoltDiv(10e-3);
voltsDiv->label("VOLTS/DIV = 10 mV");
}
void UserInterface::cb_105(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_105_i(o,v);
}

void UserInterface::cb_53_i(Fl_Button*, void*) {
  oscilloscope->setVoltDiv(5e-3);
voltsDiv->label("VOLTS/DIV = 5 mV");
}
void UserInterface::cb_53(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_53_i(o,v);
}

void UserInterface::cb_24_i(Fl_Button*, void*) {
  oscilloscope->setVoltDiv(2e-3);
voltsDiv->label("VOLTS/DIV = 2 mV");
}
void UserInterface::cb_24(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_24_i(o,v);
}

void UserInterface::cb_16_i(Fl_Button*, void*) {
  oscilloscope->setVoltDiv(1e-3);
voltsDiv->label("VOLTS/DIV = 1 mV");
}
void UserInterface::cb_16(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_16_i(o,v);
}

void UserInterface::cb_0a_i(Fl_Button*, void*) {
  oscilloscope->setVoltDiv(0.5e-3);
voltsDiv->label("VOLTS/DIV = 0.5 mV");
}
void UserInterface::cb_0a(Fl_Button* o, void* v) {
  ((UserInterface*)(o->parent()->parent()->parent()->user_data()))->cb_0a_i(o,v);
}

UserInterface::UserInterface() {
  make_window();
}

Fl_Window* UserInterface::make_window() {
  Fl_Window* w;
  { Fl_Window* o = mainWindow = new Fl_Window(905, 739, "WGO (Waveform Generator and Oscilloscope)");
    w = o;
    o->user_data((void*)(this));
    { Fl_Button* o = new Fl_Button(25, 25, 120, 25, "About WGO");
      o->labelfont(1);
      o->callback((Fl_Callback*)cb_About);
    }
    { Fl_Box* o = new Fl_Box(5, 69, 165, 61, "Please turn off both instruments before terminating the program.");
      o->align(FL_ALIGN_WRAP);
      o->when(FL_WHEN_NEVER);
    }
    { Fl_Box* o = timeDiv = new Fl_Box(690, 25, 180, 21, "TIME/DIV = 1 ms");
      o->labelfont(1);
      o->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
      o->when(FL_WHEN_NEVER);
    }
    { Fl_Box* o = voltsDiv = new Fl_Box(690, 44, 180, 21, "VOLTS/DIV = 1 V");
      o->labelfont(1);
      o->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
      o->when(FL_WHEN_NEVER);
    }
    { Fl_Group* o = new Fl_Group(10, 480, 400, 255, "Waveform Generator Control Panel");
      o->box(FL_DOWN_BOX);
      o->color((Fl_Color)215);
      o->labelfont(1);
      o->when(FL_WHEN_NEVER);
      { Fl_Button* o = new Fl_Button(20, 490, 64, 24, "Power");
        o->type(1);
        o->selection_color((Fl_Color)3);
        o->labelfont(1);
        o->callback((Fl_Callback*)cb_Power);
      }
      { Fl_Choice* o = new Fl_Choice(105, 520, 115, 24, "Waveform");
        o->down_box(FL_BORDER_BOX);
        o->menu(menu_Waveform);
      }
      { Fl_Choice* o = new Fl_Choice(350, 486, 55, 24, "DAC Channel #");
        o->down_box(FL_BORDER_BOX);
        o->menu(menu_DAC);
      }
      { Fl_Value_Slider* o = new Fl_Value_Slider(105, 550, 200, 24, "Frequency = ");
        o->type(5);
        o->color(FL_BACKGROUND2_COLOR);
        o->selection_color((Fl_Color)1);
        o->minimum(0.01);
        o->value(0.1);
        o->textsize(14);
        o->callback((Fl_Callback*)cb_Frequency);
        o->align(FL_ALIGN_LEFT);
      }
      { Fl_Choice* o = wgFrequencyOrder = new Fl_Choice(325, 551, 80, 24, "x ");
        o->down_box(FL_BORDER_BOX);
        o->menu(menu_wgFrequencyOrder);
      }
      { Fl_Value_Slider* o = new Fl_Value_Slider(105, 636, 300, 24, "DC Offset (V)");
        o->type(5);
        o->color(FL_BACKGROUND2_COLOR);
        o->selection_color((Fl_Color)1);
        o->minimum(-4);
        o->maximum(4);
        o->step(0.1);
        o->textsize(14);
        o->callback((Fl_Callback*)cb_DC);
        o->align(FL_ALIGN_LEFT);
      }
      { Fl_Value_Slider* o = new Fl_Value_Slider(105, 605, 200, 24, "Amplitude = ");
        o->type(5);
        o->color(FL_BACKGROUND2_COLOR);
        o->selection_color((Fl_Color)1);
        o->value(0.1);
        o->textsize(14);
        o->callback((Fl_Callback*)cb_Amplitude);
        o->align(FL_ALIGN_LEFT);
      }
      { Fl_Choice* o = new Fl_Choice(325, 606, 80, 24, "x ");
        o->down_box(FL_BORDER_BOX);
        o->menu(menu_x);
      }
      o->end();
    }
    { Fl_Group* o = new Fl_Group(415, 480, 485, 255, "Oscilloscope Control Panel");
      o->box(FL_DOWN_BOX);
      o->color((Fl_Color)207);
      o->labelfont(1);
      o->when(FL_WHEN_NEVER);
      { Fl_Button* o = new Fl_Button(425, 490, 64, 24, "Power");
        o->type(1);
        o->selection_color((Fl_Color)3);
        o->labelfont(1);
        o->callback((Fl_Callback*)cb_Power1);
      }
      { Fl_Choice* o = new Fl_Choice(840, 486, 55, 24, "ADC Channel #");
        o->down_box(FL_BORDER_BOX);
        o->menu(menu_ADC);
      }
      { Fl_Value_Slider* o = new Fl_Value_Slider(530, 700, 335, 25, "DC Offset (DIV)");
        o->type(5);
        o->color(FL_BACKGROUND2_COLOR);
        o->selection_color((Fl_Color)1);
        o->minimum(-10);
        o->maximum(10);
        o->step(0.1);
        o->textsize(14);
        o->callback((Fl_Callback*)cb_DC1);
        o->align(FL_ALIGN_LEFT);
      }
      { Fl_Group* o = new Fl_Group(425, 535, 470, 65, "TIME/DIV");
        o->box(FL_DOWN_FRAME);
        o->labelfont(1);
        o->when(FL_WHEN_NEVER);
        { Fl_Button* o = new Fl_Button(435, 550, 30, 25, "0.2");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_02);
        }
        { Fl_Button* o = new Fl_Button(465, 550, 30, 25, "0.1");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_03);
        }
        { Fl_Button* o = new Fl_Button(510, 550, 30, 25, "50");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_50);
        }
        { Fl_Button* o = new Fl_Button(540, 550, 30, 25, "20");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_20);
        }
        { Fl_Button* o = new Fl_Button(570, 550, 30, 25, "10");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_103);
        }
        { Fl_Button* o = new Fl_Button(600, 550, 30, 25, "5");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_51);
        }
        { Fl_Button* o = new Fl_Button(630, 550, 30, 25, "2");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_22);
        }
        { Fl_Button* o = new Fl_Button(660, 550, 30, 25, "1");
          o->type(102);
          o->value(1);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_14);
        }
        { Fl_Button* o = new Fl_Button(690, 550, 30, 25, "0.5");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_04);
        }
        { Fl_Button* o = new Fl_Button(720, 550, 30, 25, "0.2");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_05);
        }
        { Fl_Button* o = new Fl_Button(750, 550, 30, 25, "0.1");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_06);
        }
        { Fl_Button* o = new Fl_Button(795, 550, 30, 25, "50");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_501);
        }
        { Fl_Button* o = new Fl_Button(825, 550, 30, 25, "20");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_201);
        }
        { Fl_Button* o = new Fl_Button(855, 550, 30, 25, "10");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_104);
        }
        { Fl_Box* o = new Fl_Box(430, 544, 70, 37, "sec");
          o->box(FL_THIN_DOWN_FRAME);
          o->align(FL_ALIGN_BOTTOM);
          o->when(FL_WHEN_NEVER);
        }
        { Fl_Box* o = new Fl_Box(505, 543, 280, 37, "ms");
          o->box(FL_THIN_DOWN_FRAME);
          o->align(FL_ALIGN_BOTTOM);
          o->when(FL_WHEN_NEVER);
        }
        { Fl_Box* o = new Fl_Box(790, 543, 100, 37, "us");
          o->box(FL_THIN_DOWN_FRAME);
          o->align(FL_ALIGN_BOTTOM);
          o->when(FL_WHEN_NEVER);
        }
        o->end();
      }
      { Fl_Group* o = new Fl_Group(425, 625, 425, 65, "VOLTS/DIV");
        o->box(FL_DOWN_FRAME);
        o->labelfont(1);
        o->when(FL_WHEN_NEVER);
        { Fl_Button* o = new Fl_Button(435, 640, 30, 25, "5");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_52);
        }
        { Fl_Button* o = new Fl_Button(465, 640, 30, 25, "2");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_23);
        }
        { Fl_Button* o = new Fl_Button(495, 640, 30, 25, "1");
          o->type(102);
          o->value(1);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_15);
        }
        { Fl_Button* o = new Fl_Button(525, 640, 30, 25, "0.5");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_07);
        }
        { Fl_Button* o = new Fl_Button(555, 640, 30, 25, "0.2");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_08);
        }
        { Fl_Button* o = new Fl_Button(585, 640, 30, 25, "0.1");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_09);
        }
        { Fl_Button* o = new Fl_Button(630, 640, 30, 25, "50");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_502);
        }
        { Fl_Button* o = new Fl_Button(660, 640, 30, 25, "20");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_202);
        }
        { Fl_Button* o = new Fl_Button(690, 640, 30, 25, "10");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_105);
        }
        { Fl_Button* o = new Fl_Button(720, 640, 30, 25, "5");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_53);
        }
        { Fl_Button* o = new Fl_Button(750, 640, 30, 25, "2");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_24);
        }
        { Fl_Button* o = new Fl_Button(780, 640, 30, 25, "1");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_16);
        }
        { Fl_Button* o = new Fl_Button(810, 640, 30, 25, "0.5");
          o->type(102);
          o->selection_color((Fl_Color)1);
          o->callback((Fl_Callback*)cb_0a);
        }
        { Fl_Box* o = new Fl_Box(430, 634, 190, 38, "V");
          o->box(FL_THIN_DOWN_FRAME);
          o->align(FL_ALIGN_BOTTOM);
          o->when(FL_WHEN_NEVER);
        }
        { Fl_Box* o = new Fl_Box(625, 633, 220, 39, "mV");
          o->box(FL_THIN_DOWN_FRAME);
          o->align(FL_ALIGN_BOTTOM);
          o->when(FL_WHEN_NEVER);
        }
        o->end();
      }
      o->end();
    }
    { Monitor* o = monitor = new Monitor(175, 25, 501, 401, "Monitor");
      o->box(FL_BORDER_FRAME);
      o->color(FL_FOREGROUND_COLOR);
      o->selection_color(FL_BACKGROUND_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(14);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->align(FL_ALIGN_TOP);
      o->when(FL_WHEN_NEVER);
    }
    o->end();
  }
  return w;
}

void UserInterface::initialization() {
  wgFrequencyOrder->value(1);
}

Fl_Window * UserInterface::get_window() {
  return mainWindow;
}
